#ifndef TDS_TYPES_H
#define TDS_TYPES_H

/*
 * types stuff
 */

#if defined(__aix__)
#include <sys/machine.h>
# if defined( BIG_ENDIAN )
#  define TDS_BIG_ENDIAN		1
# else
#  define TDS_LITTLE_ENDIAN		1
# endif
# define HAS_AIX_GETHOSTBYNAMER	1
# define NB_USE_FCNTL			1
#endif

#if defined(__hpux__)
# define TDS_BIG_ENDIAN			1
# define HAS_TS_GETHOSTBYNAME	1
# define NB_USE_FCNTL			1
# if defined( __PA_RISC__ )
typedef size_t  socklen_t;
# endif
#endif

#if defined(__linux__)
#include <endian.h>
# if __BYTE_ORDER == __BIG_ENDIAN
#  define TDS_BIG_ENDIAN		1
# else
#  define TDS_LITTLE_ENDIAN		1
# endif
# define HAS_GETHOSTBYNAMER		1
# define NB_USE_FCNTL			1
#endif

#if defined(__solaris__)
#include <sys/isa_defs.h>
# if defined(_BIG_ENDIAN)
#  define TDS_BIG_ENDIAN        1
/*
 * choose between 5.6 and 5.8
 */
#  ifndef __IS64BIT__
typedef size_t	socklen_t;
#  endif
# else
#  define TDS_LITTLE_ENDIAN     1
# endif
# define HAS_SUN_GETHOSTBYNAMER	1
# define NEED_SYSFILEIO_H       1
# define NB_USE_FCNTL			1
#endif

typedef signed long long	tds_int64;
typedef signed int			tds_int32;
typedef signed short 		tds_int16;

typedef unsigned long long	tds_uint64;
typedef unsigned int		tds_uint32;
typedef unsigned short		tds_uint16;

/*
 * limits stuff
 */

#ifndef LLONG_MAX
# define LLONG_MAX    9223372036854775807LL
#endif

#ifndef LLONG_MIN
# define LLONG_MIN    (-LLONG_MAX - 1LL)
#endif

#ifndef ULLONG_MAX
# define ULLONG_MAX   18446744073709551615ULL
#endif

#endif
